#include <GUIConstantsEx.au3>
#include <GUIConstants.au3>
#include <Array.au3>
#include <File.au3>
#include <SliderConstants.au3>
#Include <GuiSlider.au3>
#include <WinAPI.au3>
#include <WindowsConstants.au3>

Opt("WinTitleMatchMode", 2)

DirRemove(@ScriptDir & "\temp")
DirCreate(@ScriptDir & "\temp")

Global $path_to_i_view32exe=IniRead(@ScriptDir & "\bilder_umwandeln_settings.ini","settings","path_to_i_view32exe","error")
#MsgBox(0,"",$path_to_i_view32exe)
#$return=RunWait($path_to_i_view32exe)
#(0,"",$return)
Global $supported_extensions_array_size=7
Global $supported_extensions_array[$supported_extensions_array_size]=["jpg","bmp","gif","png","tif","tiff","jpeg"]
Global $temp_directory=@ScriptDir & "\temp"

#_ArrayDisplay($supported_extensions_array)

gui_create()

While 1
   $nMsg = GUIGetMsg(1)
   Switch $nMsg[1]
   Case $hGUI1
	  Switch $nMsg[0]
	  Case $GUI_EVENT_CLOSE
		 if $preview_opened=1 Then
			ProcessClose("i_view32.exe")
		 EndIf
		 Exit

	  case $select_folder

		 if FileExists($temp_directory) Then
		 FileDelete($temp_directory)
		 EndIf


		 WinSetOnTop($hGUI1, "", 0)
		 Global $selected_file=FileOpenDialog("select image","","Alle (*.*)")
		 WinSetOnTop($hGUI1, "", 1)

		 if $selected_file<>"" Then
		 analize_input_path()
		 build_options_array()
		 #_ArrayDisplay($options_array)
		 $options_string=_ArrayToString($options_array," ")
		 #MsgBox(0,"",$options_string)
		 create_output_path()


		 #MsgBox(0,"",$path_to_i_view32exe & " " &  $selected_file &  " " & $options_string & " " &  "/convert=" & $temp_directory & "\" & $selected_file_name & ".jpg", "c:/", @SW_HIDE)
		 RunWait($path_to_i_view32exe & " " &  $selected_file &  " " & $options_string & " " &  "/convert=" & $temp_directory & "\" & $selected_file_name & ".jpg", "c:/", @SW_HIDE)

		 #MsgBox(0,"",$path_to_i_view32exe & $temp_directory & "\" & $selected_file_name & ".jpg")
		 Run($path_to_i_view32exe & " " & $temp_directory & "\" & $selected_file_name & ".jpg")
		 WinActivate("bilder_umwandeln")

		 EndIf
		 GUICtrlSetState($ok_button,$GUI_FOCUS)

	  Case $reset_button
		 GUICtrlSetData($input1, 30)
		 GUICtrlSetData($input2, 50)
		 GUICtrlSetData($input3, 0)
		 GUICtrlSetData($input4, 0)
		 GUICtrlSetData($input5, 100)
		 GUICtrlSetState($rechts_drehen, $GUI_UNCHECKED)
		 GUICtrlSetState($links_drehen, $GUI_UNCHECKED)
		 GUICtrlSetState($180_drehen, $GUI_UNCHECKED)
		 GUICtrlSetData($input6, "")
		 update_preview()
		 GUICtrlSetState($ok_button,$GUI_FOCUS)

	  case $ok_button
		 if $selected_folder="" Then
			MsgBox(0,"","no folder")
		 Else

			if FileExists($temp_directory) Then
			FileDelete($temp_directory)
			EndIf


			build_options_array()
			#_ArrayDisplay($options_array)
			$options_string=_ArrayToString($options_array," ")
			#MsgBox(0,"",$options_string)
			create_output_path()

			$Ret = _MyMsgBox("", "Which files should be processed?", 300, 100, "one", "all", "cancel", WinGetHandle(""))

			if $iRet_Value=2 then
			   #MsgBox(0,"","all files")

			   $pdf_name=GUICtrlRead($input6)
			   if $pdf_name <> "" Then

				  for $i=0 to ($supported_extensions_array_size-1)
					 #MsgBox(0,"",$path_to_i_view32exe & " " &  $selected_folder & "\*." & $supported_extensions_array[$i] & " " & $options_string & " " & $output_path_for_irfan)
					 RunWait($path_to_i_view32exe & " " &  $selected_folder & "\*." & $supported_extensions_array[$i] & " " & $options_string & " " & "/convert=" & $temp_directory &  "\" & "*.jpg", "c:/", @SW_HIDE)
				  Next

				  ;example: C:\JPEGtoPDF.exe "C:\rollo.PDF" "C:\input\*.*"
				  RunWait(@ScriptDir & "\JPEGtoPDF.exe " & '"' & $selected_folder_parent & "\" & $pdf_name & ".PDF" & '" ' & '"' & $temp_directory &  "\" & "*.jpg" & '"')

			   Else
				  ;example: C:\Programme\IrfanView\i_view32.exe c:\input\* /jpgq=30 /convert=c:\output\*.jpg
				  ;c:\images\ /filepattern="*.jpg"
				  for $i=0 to ($supported_extensions_array_size-1)
					 #MsgBox(0,"",$path_to_i_view32exe & " " &  $selected_folder & "\*." & $supported_extensions_array[$i] & " " & $options_string & " " & $output_path_for_irfan)
					 RunWait($path_to_i_view32exe & " " &  $selected_folder & "\*." & $supported_extensions_array[$i] & " " & $options_string & " " & "/convert=" & $selected_folder & "_output" & "\" & "*.jpg", "c:/", @SW_HIDE)
				  Next

			   EndIf

			   ProcessClose("i_view32.exe")
			   GUICtrlSetData($SourceInput,"")
			   #MsgBox(0,"","fertig",1)

			ElseIf $iRet_Value=1 Then
			   #MsgBox(0,"","one file")

			   $pdf_name=GUICtrlRead($input6)
			   if $pdf_name <> "" Then

				  RunWait($path_to_i_view32exe & " " &  $selected_file &  " " & $options_string & " " &  "/convert=" & $temp_directory & "\" & $selected_file_name & "_output.jpg", "c:/", @SW_HIDE)
				  ;example: C:\JPEGtoPDF.exe "C:\rollo.PDF" "C:\input\*.*"
				  RunWait(@ScriptDir & "\JPEGtoPDF.exe " & '"' & $selected_folder & "\" & $pdf_name & '.PDF" ' & '"' & $temp_directory & "\" & $selected_file_name & "_output.jpg" & '"')

			   Else
				  RunWait($path_to_i_view32exe & " " &  $selected_file &  " " & $options_string & " " &  "/convert=" & $selected_folder & "\" & $selected_file_name & "_output.jpg", "c:/", @SW_HIDE)

			   EndIf

			   ProcessClose("i_view32.exe")
			   GUICtrlSetData($SourceInput,"")
			   #MsgBox(0,"","fertig",1)

			ElseIf $iRet_Value=3 Then
			   #MsgBox(0,"","cancel")
			EndIf


		 EndIf

	  case $nMsg[0]=$180_drehen or $nMsg[0]=$links_drehen or $nMsg[0]=$rechts_drehen or $nMsg[0]=$input1 OR $nMsg[0]=$input2 OR $nMsg[0]=$input3 OR $nMsg[0]=$input4 OR $nMsg[0]=$input5
		 update_preview()

	  Case Else
		 check_if_preview_opened()
		 update_labels()

	  EndSwitch
   EndSwitch
WEnd


Func analize_input_path()
		 $right_backslash_pos=StringInStr($selected_file,"\",0,-1)
		 $selected_folder=StringMid($selected_file,1,$right_backslash_pos-1)
		 #MsgBox(0,"",$selected_folder)

		 Local $szDrive, $szDir, $szFName, $szExt
		 Local $path_split_array=_PathSplit($selected_file, $szDrive, $szDir, $szFName, $szExt)
		# _ArrayDisplay($path_split_array)
		 Global $selected_file_name=$path_split_array[3]
		 Global $selected_file_extension=$path_split_array[4]

		 GUICtrlSetData($SourceInput, $selected_file, "")
EndFunc

Func update_labels()
			$input1_return = GUICtrlRead($input1)
			#ToolTip("",0,0)
            If $input1_return_old <> $input1_return Then
			   $input1_return_old = $input1_return
			   GUICtrlSetData($label1, "Qualitt: " & $input1_return_old )
			EndIf

			$input2_return = GUICtrlRead($input2)
			#ToolTip("",0,0)
            If $input2_return_old <> $input2_return Then
			   $input2_return_old = $input2_return
			   GUICtrlSetData($label2, "schrfen: " & $input2_return_old )
			EndIf

			$input3_return = GUICtrlRead($input3)
			#ToolTip($input3_return,0,0)
            If $input3_return_old <> $input3_return Then
			   $input3_return_old = $input3_return
			   GUICtrlSetData($label3, "Kontrast: " & $input3_return_old )
			EndIf

            $input4_return = GUICtrlRead($input4)
			#ToolTip("",0,0)
            If $input4_return_old <> $input4_return Then
			   $input4_return_old = $input4_return
			   GUICtrlSetData($label4, "Helligkeit: " & $input4_return_old*15 )
			EndIf


			$input5_return = GUICtrlRead($input5)
			#ToolTip($input5_return/100,0,0)
            If $input5_return_old <> $input5_return Then
			   $input5_return_old = $input5_return
			   GUICtrlSetData($label5, "Gamma: " & $input5_return_old/100 )
			EndIf
EndFunc

Func check_if_preview_opened()
   Global $preview_opened
   $i_view_process_exists=ProcessExists("i_view32.exe")
   #SplashTextOn("",$i_view_process_exists,200,80,0,0)
   if $i_view_process_exists=0 Then
   $preview_opened=0
   Else
   $preview_opened=1
   EndIf
EndFunc


Func gui_create()

$gui_width=210
$gui_heigt=305

Global $hGUI1=GUICreate("bilder_umwandeln",$gui_width,$gui_heigt,0,0)
WinSetOnTop($hGUI1, "", 1)

#GUIRegisterMsg(0x0111,'WM_COMMAND')
GUISetState(@SW_SHOW, $hGui1)

$ok_button_width=70
$ok_button_height=25

$file_button_width=40
$SourceInput_top=10
Global $SourceInput = GUICtrlCreateInput("", 10, $SourceInput_top, $gui_width-$file_button_width-10, 20)
Global $select_folder=GUICtrlCreateButton("File", $gui_width-$file_button_width,$SourceInput_top,$file_button_width,20)

Global $rechts_drehen=GUICtrlCreateCheckbox("rechts_drehen", 10, 35, 120, 20)
Global $links_drehen=GUICtrlCreateCheckbox("links_drehen", 10, 60, 120, 20)
Global $180_drehen=GUICtrlCreateCheckbox("180_drehen", 10, 85, 120, 20)

$input1_width=100
$input1_top=110
Global $input1=GUICtrlCreateSlider(10, $input1_top, $input1_width, 20,$TBS_NOTICKS);,BitOR($TBS_TOOLTIPS, $TBS_AUTOTICKS))
GUICtrlSetLimit($input1, 100, 1) ; change min/max value
GUICtrlSetData($input1, 30) ; set cursor
Global $label1=GUICtrlCreateLabel("Qualitt: 30",$input1_width+15,$input1_top,$gui_width-($input1_width+15+10),20)
Global $input1_return = 0
Global $input1_return_old = 0

$input2_top=135
Global $input2=GUICtrlCreateSlider(10, $input2_top, $input1_width, 20,$TBS_NOTICKS);,BitOR($TBS_TOOLTIPS, $TBS_AUTOTICKS))
GUICtrlSetLimit($input2, 99, 1) ; change min/max value
GUICtrlSetData($input2, 50) ; set cursor
Global $label2=GUICtrlCreateLabel("schrfen: 50",$input1_width+15,$input2_top,$gui_width-($input1_width+15+10),20)
Global $input2_return = 0
Global $input2_return_old = 0

$input3_top=160
Global $input3=GUICtrlCreateSlider(10, $input3_top, $input1_width, 20,$TBS_NOTICKS);,BitOR($TBS_TOOLTIPS, $TBS_AUTOTICKS))
GUICtrlSetLimit($input3, 127, -127) ; change min/max value
GUICtrlSetData($input3, 0) ; set cursor
Global $label3=GUICtrlCreateLabel("Kontrast: 0",$input1_width+15,$input3_top,$gui_width-($input1_width+15+10),20)
Global $input3_return = 0
Global $input3_return_old = 0

$input4_top=185
Global $input4=GUICtrlCreateSlider(10, $input4_top, $input1_width, 20,$TBS_NOTICKS);,BitOR($TBS_TOOLTIPS, $TBS_AUTOTICKS))
GUICtrlSetLimit($input4, 17, -17) ; change min/max value
GUICtrlSetData($input4, 0) ; set cursor
Global $label4=GUICtrlCreateLabel("Helligkeit: 0",$input1_width+15,$input4_top,$gui_width-($input1_width+15+10),20)
Global $input4_return = 0
Global $input4_return_old = 0

$input5_top=210
Global $input5=GUICtrlCreateSlider(10, $input5_top, $input1_width, 20,$TBS_NOTICKS);,BitOR($TBS_TOOLTIPS, $TBS_AUTOTICKS))
GUICtrlSetLimit($input5, 699, 1) ; change min/max value
GUICtrlSetData($input5, 100) ; set cursor
Global $label5=GUICtrlCreateLabel("Gamma: 1",$input1_width+15,$input5_top,$gui_width-($input1_width+15+10),20)
Global $input5_return = 0
Global $input5_return_old = 0

$input6_top=235
Global $input6=GUICtrlCreateInput("",10, $input6_top, $input1_width, 20);,$TBS_NOTICKS);,BitOR($TBS_TOOLTIPS, $TBS_AUTOTICKS))
Global $label6=GUICtrlCreateLabel("pdf name (ex.)",$input1_width+15,$input6_top,$gui_width-($input1_width+15+10),20)

Global $selected_folder=""

Global $ok_button=GUICtrlCreateButton("ok",$gui_width-$ok_button_width,$gui_heigt-$ok_button_height,$ok_button_width,$ok_button_height);,$BS_DEFPUSHBUTTON)
GUICtrlSetState($ok_button,$GUI_DEFBUTTON)

Global $reset_button=GUICtrlCreateButton("reset",0,$gui_heigt-$ok_button_height,$ok_button_width,$ok_button_height);,$BS_DEFPUSHBUTTON)
#GUICtrlSetState($ok_button,$GUI_DEFBUTTON)

EndFunc

Func _MyMsgBox($sTitle, $sPrompt, $iWidth, $iHeghit, $sButton1, $sButton2="", $sButton3="", $hParent_hWnd=0)
    Global $iOld_Opt_GOEM, $hMsgBox, $iRet_Value = 0
    Local $iButton1 = -1, $iButton2 = -1, $iButton3 = -1

    $iOld_Opt_GOEM = Opt("GuiOnEventMode", 0)

    If IsHWnd($hParent_hWnd) Then WinSetState($hParent_hWnd, "", @SW_DISABLE)

    $hMsgBox = GUICreate($sTitle, $iWidth, $iHeghit, -1, -1, $WS_CAPTION+$WS_SYSMENU, -1, $hParent_hWnd)
    GUICtrlCreateLabel($sPrompt, 20, 20, $iWidth - 40)

    If $sButton2 <> "" And $sButton3 = "" Then
        $iButton1 = GUICtrlCreateButton($sButton1, ($iWidth / 2) - 90, $iHeghit - 40, 60, 20)
        $iButton2 = GUICtrlCreateButton($sButton2, ($iWidth / 2) + 30, $iHeghit - 40, 60, 20)
    ElseIf $sButton3 <> "" Then
        $iButton1 = GUICtrlCreateButton($sButton1, 40, $iHeghit - 40, 60, 20)
        $iButton2 = GUICtrlCreateButton($sButton2, ($iWidth / 2) - 30, $iHeghit - 40, 60, 20)
        $iButton3 = GUICtrlCreateButton($sButton3, $iWidth - 100, $iHeghit - 40, 60, 20)
    Else
        $iButton1 = GUICtrlCreateButton($sButton1, ($iWidth / 2) - 30, $iHeghit - 40, 60, 20)
    EndIf

    GUISetState(@SW_SHOW, $hMsgBox)
    GUICtrlSetState($iButton1,$GUI_FOCUS)

    While 1
        Switch GUIGetMsg()
            Case $GUI_EVENT_CLOSE
                ExitLoop
            Case $iButton1
                $iRet_Value = 1
				#MsgBox(0,"",$iRet_Value)
                ExitLoop
            Case $iButton2
                $iRet_Value = 2
				#MsgBox(0,"",$iRet_Value)
                ExitLoop
            Case $iButton3
                $iRet_Value = 3
                ExitLoop
        EndSwitch
    WEnd

    If IsHWnd($hParent_hWnd) Then WinSetState($hParent_hWnd, "", @SW_ENABLE)
    GUIDelete($hMsgBox)
    Opt("GuiOnEventMode", $iOld_Opt_GOEM)
    Return $iRet_Value
EndFunc

Func update_preview()
	  #MsgBox(0,"","slider verndert")

		 if $preview_opened=1 Then
			build_options_array()
			#_ArrayDisplay($options_array)
			$options_string=_ArrayToString($options_array," ")
			#MsgBox(0,"",$options_string)

			;example: C:\Programme\IrfanView\i_view32.exe c:\input\* /jpgq=30 /convert=c:\output\*.jpg
			;c:\images\ /filepattern="*.jpg"
			RunWait($path_to_i_view32exe & " " &  $selected_file & " " & $options_string & " " & "/convert=" & $temp_directory & "\" & $selected_file_name & ".jpg", "c:/", @SW_HIDE)


			#$pid_of_first_irfan_view=ProcessExists("i_view32.exe")
			#Run("C:\Programme\IrfanView\i_view32.exe " & $temp_directory & "\" & $selected_file_name & ".jpg")
			#ProcessClose($pid_of_first_irfan_view)

			WinSetState("bilder_umwandeln","",@SW_HIDE)
			Sleep(100)
			#ControlSend("IrfanView","","","+r")
			#WinActivate("IrfanView")
			send("+r")
			#WinActivate("bilder_umwandeln")
			WinSetState("bilder_umwandeln","",@SW_SHOW)
		 EndIf
EndFunc

Func build_options_array()
   Global $options_array[1]

   $rechts_drehen_return=GUICtrlRead($rechts_drehen)
   if $rechts_drehen_return=1 Then
   _ArrayAdd($options_array, "/rotate_r")
   EndIf

   $links_drehen_return=GUICtrlRead($links_drehen)
   if $links_drehen_return=1 Then
   _ArrayAdd($options_array, "/rotate_l")
   EndIf

   $180_drehen_return=GUICtrlRead($180_drehen)
   if $180_drehen_return=1 Then
   _ArrayAdd($options_array, "/hflip /vflip")
   EndIf

   $input1_return=GUICtrlRead($input1)
   #MsgBox(0,"",$input1_return)
   if $input1_return<>100 Then
	  #MsgBox(0,"","array add quality")
   _ArrayAdd($options_array, "/jpgq=" & $input1_return)
   EndIf

   $input2_return=GUICtrlRead($input2)
   #MsgBox(0,"",$input2_return)
   if $input2_return<>50 Then
   _ArrayAdd($options_array, "/sharpen=" & $input2_return)
   EndIf

   $input3_return=GUICtrlRead($input3)
   if $input3_return<>0 Then
   _ArrayAdd($options_array, "/contrast=" & $input3_return)
   EndIf

   $input4_return=GUICtrlRead($input4)
   if ($input4_return*15)<>0 Then
   _ArrayAdd($options_array, "/bright=" & $input4_return*15)
   EndIf

  $input5_return=GUICtrlRead($input5)
   if ($input5_return/100)<>1 Then
   _ArrayAdd($options_array, "/gamma=" & $input5_return/100)
   EndIf

   #_ArrayDisplay($options_array)
EndFunc

Func create_output_path()
   $last_backslash_pos=StringInStr($selected_folder,"\",0,-1)
   Global $selected_folder_parent=StringMid($selected_folder,1,$last_backslash_pos-1)
   #MsgBox(0,"",$selected_folder_parent)

   $foldername=StringMid($selected_folder,$last_backslash_pos+1)
   #MsgBox(0,"",$selected_folder)
   #MsgBox(0,"",$foldername)

   Global $output_path=$selected_folder_parent & "\" & $foldername & "_output"
   #MsgBox(0,"",$output_path)

   ;example: C:\Programme\IrfanView\i_view32.exe c:\input\* /jpgq=30 /convert=c:\output\*.jpg
   Global $output_path_for_irfan="/convert=" & $selected_folder_parent & "\" & $foldername & "_output\*.jpg"
   #MsgBox(0,"",$output_path_for_irfan)
EndFunc
